C boring cyclic !!
      SUBROUTINE AD_MAIN ()
        IMPLICIT INTEGER (I-K), REAL (R-T), DOUBLE PRECISION (D-F), COMP
     *LEX (X-Z), CHARACTER (A-C), LOGICAL (L-N)
        
        INTEGER :: K_MRES (0:24)
        INTEGER :: K_MA (0:24)
        INTEGER :: K_MB (0:24)
        
        REAL, DIMENSION (0:4, 0:12) :: R_RES
        INTEGER, DIMENSION (0:1) :: K_PQ
        INTEGER :: I_I
        INTEGER :: I_J
        INTEGER, DIMENSION (0:11, 0:9) :: I_A
        INTEGER, DIMENSION (0:1) :: K_PP
        REAL, DIMENSION (0:19, 0:1) :: R_B
        INTEGER, DIMENSION (0:0) :: K_PR
        
        LOGICAL  N_FIRSTCALL
        DATA     N_FIRSTCALL /.TRUE./
        INTEGER  ::  K_Q, K_H0, K_H1, K_H2, K_H3, K_H4, K_H5, K_H6, K_H7
     *, K_P0, K_P1 (0:0), K_P2 (0:1), K_P3 (0:2), K_P4 (0:3), K_P5 (0:4)
     *, K_P6 (0:5), K_P7 (0:6)
        COMMON /Q_PROCS/ K_Q, K_H0, K_H1, K_H2, K_H3, K_H4, K_H5, K_H6, 
     *K_H7, K_P0, K_P1, K_P2, K_P3, K_P4, K_P5, K_P6, K_P7
        
        INTEGER           ::  K_PTR, K_Z, K_TMP (0 : 299999)
        REAL              ::  T_TMP (0 : 299999)
        DOUBLE PRECISION  ::  F_TMP (0 : 149999)
        COMPLEX           ::  Z_TMP (0 : 149999)
        LOGICAL           ::  N_TMP (0 : 299999)
        EQUIVALENCE (K_TMP, T_TMP, F_TMP, Z_TMP, N_TMP)
        COMMON /Q_STACK/ K_PTR, K_Z, K_TMP
        
        K_PTR = 0
        
        CALL AD_INIT_PROCS (K_H1, 1, (/1/))
        CALL AD_PROC_COORD (K_H1, K_P1)
        CALL AD_INIT_PROCS (K_H2, 2, (/1, 1/))
        CALL AD_PROC_COORD (K_H2, K_P2)
        CALL AD_INIT_PROCS (K_H3, 3, (/1, 1, 1/))
        CALL AD_PROC_COORD (K_H3, K_P3)
        CALL AD_INIT_PROCS (K_H4, 4, (/1, 1, 1, 1/))
        CALL AD_PROC_COORD (K_H4, K_P4)
        CALL AD_INIT_PROCS (K_H5, 5, (/1, 1, 1, 1, 1/))
        CALL AD_PROC_COORD (K_H5, K_P5)
        CALL AD_INIT_PROCS (K_H6, 6, (/1, 1, 1, 1, 1, 1/))
        CALL AD_PROC_COORD (K_H6, K_P6)
        CALL AD_INIT_PROCS (K_H7, 7, (/1, 1, 1, 1, 1, 1, 1/))
        CALL AD_PROC_COORD (K_H7, K_P7)
        CALL AD_INIT_PROCS (K_HQ, 2, (/2, 3/))
        CALL AD_PROC_COORD (K_HQ, K_PQ)
        CALL AD_INIT_PROCS (K_HP, 2, (/3, 2/))
        CALL AD_PROC_COORD (K_HP, K_PP)
        CALL AD_INIT_PROCS (K_HR, 1, (/6/))
        CALL AD_PROC_COORD (K_HR, K_PR)
        
        K_MRES = (/66, 0, K_HQ, 0, 0, 15, 10, 1, 1, 5, 13, 0, 18, 15, 10
     *, 1, -1, 20, 25, 5, 13, 4, 2, 1, 0/)
        K_MA = (/66, 0, K_HP, 0, 0, 15, 20, 1, 1, 12, 10, 6, 0, 15, 20, 
     *2, 1, 50, 20, 1, 10, 4, 2, 0, 1/)
        K_MB = (/66, 0, K_HR, 0, 0, 20, 10, 1, 1, 20, 2, 0, 0, 20, 10, 1
     *, 1, 20, 10, 20, 2, 1, 2, -1, 0/)
        
        DO 10 I_I = 1, 15
          DO 20 I_J = 1, 20
            IF (K_PP(0) == MOD((I_I-1)*2+6,3) .AND. K_PP(1) == (I_J-1)/1
     *0) THEN
              K_V0 = ((I_I-1)*2+6)/3
              K_V1 = MOD(I_J-1,10)
              I_A (K_V0,K_V1) = I_I*I_J
            ENDIF
            
   20     CONTINUE
   10   CONTINUE
        DO 30 I_J = 1, 20
          DO 40 I_K = 1, 10
            IF (K_PR(0) == (I_K-1)/2) THEN
              K_V0 = I_J-1
              K_V1 = MOD(I_K-1,2)
              R_B (K_V0,K_V1) = 1.0/(I_J+I_K)
            ENDIF
            
   40     CONTINUE
   30   CONTINUE
        K_T0 = K_PTR;   K_PTR = K_PTR + 66
        IF (K_PTR .GT. 300000) CALL AD_STACK_ERR (300000)
        CALL AD_MATMUL_IR (T_TMP(K_T0), K_MRES, I_A, K_MA, R_B, K_MB)
        
        DO K_C0 = 0, 0
          K_V0 = K_C0*5
          K_V1 = K_PQ(0)*13
          K_V2 = MIN(-K_V1+18,12)
          K_V3 = K_C0*5+MIN(-(K_C0*3+K_PQ(1))*5+14,4)
          K_V4 = MAX(-K_V1+9,0)
          K_T0_1 = K_T0 + (K_V0+K_V2*5)
          DO K_1 = K_V2, K_V4, -1
            K_T0_0 = K_T0_1
            DO K_0 = K_V0, K_V3
              R_RES (K_0,K_1) = T_TMP (K_T0_0)
              K_T0_0 = K_T0_0 + (1)
            ENDDO
            K_T0_1 = K_T0_1 + (-5)
          ENDDO
        ENDDO
        
        K_PTR = K_PTR - 66
        DO 50 I_I = 1, 15
          K_T0 = K_PTR;   K_PTR = K_PTR + 10
          IF (K_PTR .GT. 300000) CALL AD_STACK_ERR (300000)
          K_M0 = K_PTR;   K_PTR = K_PTR + 14
          IF (K_PTR .GT. 300000) CALL AD_STACK_ERR (300000)
          K_TMP (K_M0 : K_M0+13) = (/257, 0, K_H0, 0, 10, 1, 10, 0, 10, 
     *1, 10, 10, 1, -1/)
          
          K_M1 = K_PTR;   K_PTR = K_PTR + 26
          IF (K_PTR .GT. 300000) CALL AD_STACK_ERR (300000)
          K_TMP (K_M1 : K_M1+8) = (/66, 0, K_HQ, I_I-1, 0, -1, 10, 1, 1/
     *)
          K_TMP (K_M1+9 : K_M1+24) = K_MRES (9 : 24)
          
          CALL AD_REMAP_RR (T_TMP(K_T0), K_TMP(K_M0), R_RES, K_TMP(K_M1)
     *)
          K_PTR = K_PTR - 26
          
          IF (K_P0 == 0) THEN
            PRINT "(10f7.2)", T_TMP(K_T0:K_T0+(9))
          ENDIF
          K_PTR = K_PTR - 24
   50   CONTINUE
        CALL AD_DELETE_PROCS (K_HQ)
        CALL AD_DELETE_PROCS (K_HP)
        CALL AD_DELETE_PROCS (K_HR)
        
        CALL AD_DELETE_PROCS (K_H7)
        CALL AD_DELETE_PROCS (K_H6)
        CALL AD_DELETE_PROCS (K_H5)
        CALL AD_DELETE_PROCS (K_H4)
        CALL AD_DELETE_PROCS (K_H3)
        CALL AD_DELETE_PROCS (K_H2)
        CALL AD_DELETE_PROCS (K_H1)
        CALL AD_DELETE_PROCS (K_H0)
        
      END
